package awais.instagrabber.utils.dialogs;

import android.app.Dialog;
import android.content.Context;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.text.SpannableStringBuilder;
import android.text.method.LinkMovementMethod;
import android.text.style.RelativeSizeSpan;
import android.text.style.URLSpan;
import android.view.View;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.widget.LinearLayoutCompat;

import com.google.android.material.bottomsheet.BottomSheetDialogFragment;

import awais.instagrabber.R;
import awais.instagrabber.utils.Utils;

public class AboutDialog extends BottomSheetDialogFragment {
    @NonNull
    @Override
    public Dialog onCreateDialog(@Nullable final Bundle savedInstanceState) {
        final Dialog dialog = super.onCreateDialog(savedInstanceState);
        final Context context = getContext();
        final View contentView = View.inflate(context, R.layout.main_about_dialog, null);

        if (context != null) {
            final LinearLayoutCompat infoContainer = contentView.findViewById(R.id.infoContainer);

            infoContainer.getChildAt(1).setOnClickListener(v ->
                    startActivity(new Intent(Intent.ACTION_VIEW, Uri.parse("https://gitlab.com/AwaisKing/instagrabber/"))));

            //This started off as a small and basic little personal app with intentions of [steali- ]downloading posts off Instagram.
            //I have a quick temper and I'm pretty impatient sometimes {… usually… most of the time… OK! all the time }andthank God almost every insta downloader has alteast one ad provider, so i decided to make my own downloader.
            //So here it is, the stupid little app to make that happen.
            //
            //Anyhow, if you{ or ur mom} has a question or any query, hmu on telegram or email.
            //Telegram: @awais404
            //Email: chapter50000@hotmail.com (yeah 50,000 chapters! 😎🤘)

            final String description = context.getString(R.string.description);
            if (!Utils.isEmpty(description)) {
                final TextView textView = (TextView) infoContainer.getChildAt(0);

                final SpannableStringBuilder descriptionText = new SpannableStringBuilder(description, 0, description.length());

                int lastIndex = descriptionText.length() / 2;
                for (int i = 0; i < descriptionText.length(); ++i) {
                    char c = descriptionText.charAt(i);

                    if (c == '[') {
                        final int smallTextStart = i;
                        descriptionText.delete(i, i + 1);

                        do {
                            c = descriptionText.charAt(i);
                            if (c == ']') {
                                descriptionText.delete(i, i + 1);
                                descriptionText.setSpan(new RelativeSizeSpan(0.5f), smallTextStart, i , 0);
                            }
                            ++i;
                        } while (c != ']' || i == descriptionText.length() - 1);
                    } else if (c == '{') {
                        final int smallerTextStart = i;
                        descriptionText.delete(i, i + 1);
                        i = smallerTextStart;

                        do {
                            c = descriptionText.charAt(i);
                            if (c == '}') {
                                descriptionText.delete(i, i + 1);
                                descriptionText.setSpan(new RelativeSizeSpan(0.35f), smallerTextStart, i, 0);
                            }
                            ++i;
                            lastIndex = i;
                        } while (c != '}' || i == descriptionText.length() - 1);
                    }
                }

                lastIndex = Utils.indexOfChar(descriptionText, '@', lastIndex);
                descriptionText.setSpan(new URLSpan("https://t.me/awais404"), lastIndex, lastIndex + 9, 0);

                lastIndex = Utils.indexOfChar(descriptionText, ':', lastIndex + 9) + 2;
                descriptionText.setSpan(new URLSpan("mailto:chapter50000@hotmail.com"), lastIndex, lastIndex + 24, 0);

                textView.setMovementMethod(new LinkMovementMethod());
                textView.setText(descriptionText, TextView.BufferType.SPANNABLE);
            }
        }

        dialog.setContentView(contentView);
        return dialog;
    }
}